"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeArguments = exports.assert = void 0;
function assert(statement, error) {
    if (!statement) {
        throw new Error(error);
    }
}
exports.assert = assert;
/*
 * Replace null argument values by undefined so that it works well
 * with Tone.js optional arguments.
 */
function normalizeArguments(args, argsKeys) {
    return argsKeys.map((name) => {
        if (args[name].value === null) {
            return undefined;
        }
        else {
            return args[name].value;
        }
    });
}
exports.normalizeArguments = normalizeArguments;
//# sourceMappingURL=utils.js.map