"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SplitModel = exports.MergeModel = exports.SoloModel = exports.PannerModel = exports.CrossFadeModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const tone = __importStar(require("tone"));
const widget_base_1 = require("./widget_base");
class CrossFadeModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: CrossFadeModel.model_name, _a: undefined, _b: undefined, _fade: undefined });
    }
    createNode() {
        return new tone.CrossFade({ fade: this.fade.value });
    }
    setSubNodes() {
        super.setSubNodes();
        this.a.setNode(this.node.a);
        this.b.setNode(this.node.b);
        this.fade.setNode(this.node.fade);
    }
    get a() {
        return this.get('_a');
    }
    get b() {
        return this.get('_b');
    }
    get fade() {
        return this.get('_fade');
    }
}
exports.CrossFadeModel = CrossFadeModel;
CrossFadeModel.serializers = Object.assign(Object.assign({}, widget_base_1.AudioNodeModel.serializers), { _a: { deserialize: base_1.unpack_models }, _b: { deserialize: base_1.unpack_models }, _fade: { deserialize: base_1.unpack_models } });
CrossFadeModel.model_name = 'CrossFadeModel';
class PannerModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: PannerModel.model_name, _pan: undefined });
    }
    createNode() {
        return new tone.Panner({ pan: this.pan.value });
    }
    setSubNodes() {
        super.setSubNodes();
        this.pan.setNode(this.node.pan);
    }
    get pan() {
        return this.get('_pan');
    }
}
exports.PannerModel = PannerModel;
PannerModel.serializers = Object.assign(Object.assign({}, widget_base_1.AudioNodeModel.serializers), { _pan: { deserialize: base_1.unpack_models } });
PannerModel.model_name = 'PannerModel';
class SoloModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: SoloModel.model_name, solo: false });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        // keep track of all instances for syncing models
        SoloModel._allSoloModels.add(this);
    }
    createNode() {
        return new tone.Solo({ solo: this.solo });
    }
    get solo() {
        return this.get('solo');
    }
    set solo(solo) {
        this.node.solo = solo;
        // synchronize all solo models (their gain param)
        SoloModel._allSoloModels.forEach((instance) => {
            const gainParam = instance.input.gain;
            gainParam.set('value', gainParam.node.value);
            gainParam.save_changes();
        });
    }
    initEventListeners() {
        super.initEventListeners();
        this.on('change:solo', () => {
            this.solo = this.get('solo');
        });
    }
}
exports.SoloModel = SoloModel;
SoloModel._allSoloModels = new Set();
SoloModel.model_name = 'SoloModel';
class MergeModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: MergeModel.model_name, _channels: 2 });
    }
    createNode() {
        return new tone.Merge({ channels: this.get('_channels') });
    }
}
exports.MergeModel = MergeModel;
MergeModel.model_name = 'MergeModel';
class SplitModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: SplitModel.model_name, _channels: 2 });
    }
    createNode() {
        return new tone.Split({ channels: this.get('_channels') });
    }
}
exports.SplitModel = SplitModel;
SplitModel.model_name = 'SplitModel';
//# sourceMappingURL=widget_channel.js.map