/// <reference types="backbone" />
import { ISerializers } from '@jupyter-widgets/base';
import * as tone from 'tone';
import { AudioNodeModel } from './widget_base';
import { ParamModel } from './widget_core';
import { SignalModel } from './widget_signal';
export declare class DistortionModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.Distortion;
    initEventListeners(): void;
    node: tone.Distortion;
    static model_name: string;
}
export declare class FeedbackDelayModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.FeedbackDelay;
    setSubNodes(): void;
    get delayTime(): ParamModel<'time'>;
    get feedback(): ParamModel<'normalRange'>;
    static serializers: ISerializers;
    node: tone.FeedbackDelay;
    static model_name: string;
}
export declare class PingPongDelayModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.PingPongDelay;
    setSubNodes(): void;
    get delayTime(): SignalModel<'time'>;
    get feedback(): SignalModel<'normalRange'>;
    static serializers: ISerializers;
    node: tone.PingPongDelay;
    static model_name: string;
}
export declare class ReverbModel extends AudioNodeModel {
    defaults(): any;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    createNode(): tone.Reverb;
    initEventListeners(): void;
    node: tone.Reverb;
    static model_name: string;
}
export declare class TremoloModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.Tremolo;
    setSubNodes(): void;
    get frequency(): SignalModel<'frequency'>;
    get depth(): SignalModel<'normalRange'>;
    get type(): tone.ToneOscillatorType;
    initEventListeners(): void;
    private handleMsg;
    static serializers: ISerializers;
    node: tone.Tremolo;
    static model_name: string;
}
export declare class VibratoModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.Vibrato;
    setSubNodes(): void;
    get frequency(): SignalModel<'frequency'>;
    get depth(): ParamModel<'normalRange'>;
    get type(): tone.ToneOscillatorType;
    initEventListeners(): void;
    static serializers: ISerializers;
    node: tone.Vibrato;
    static model_name: string;
}
